﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json.Linq;
using System.Threading;


namespace signerSessionCreation
{
    class signerSessionCreation
    {
        private static string api_key = "api_key";
        private static string api_url = "https://sandbox.esignlive.com/api";

        public static void Main(string[] args)
        {
            //Create Package
            string jsonString = "{ \"type\": \"PACKAGE\", \"status\": \"SENT\", \"name\": \"Example Package\", \"roles\": [ { \"id\": \"Signer1\", \"type\": \"SIGNER\", \"signers\": [ { \"firstName\": \"James\", \"lastName\": \"Smith\", \"email\": \"price9872@gmail.com\", \"id\" : \"Signer1\" } ] } ], \"documents\": [ { \"approvals\": [ { \"role\": \"Signer1\",\"fields\": [ { \"page\": 0, \"subtype\": \"FULLNAME\", \"left\": 100, \"top\": 100, \"type\": \"SIGNATURE\" } ] } ], \"name\": \"Test Document\" } ] }";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/pdf/doc1.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"doc1.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"doc1.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", api_key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(api_url) + "/packages/", form).Result;
            JObject obj = JObject.Parse(response.Content.ReadAsStringAsync().Result);

            string packageId = obj["id"].ToString();

            jsonString = "{\"packageId\": \"" + packageId + "\",\"signerId\":\"Signer1\"}";
            jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            response = myClient.PostAsync(new Uri(api_url) + "/signerAuthenticationTokens/", jsonContent).Result;
            obj = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            string signerToken = obj["value"].ToString();
            Debug.WriteLine("https://sandbox.eSignLive.com/access?sessionToken=" + signerToken);
        }

    }
}